<!--智能锁-->
<template>
  <div class="app-container smartAlarm">
    <div class="smartAlarm-min-page" v-if="pageType == 1">
      <el-form :model="queryParamsData" class="form-box" ref="queryForm" :inline="true">
        <el-form-item label="关键字" prop="searchValue">
          <el-input
            style="width:210px;"
            maxLength="30"
            v-model="queryParamsData.searchValue"
            placeholder="设备编号/名称/实验室/机柜"
            clearable
            size="small"
          />
        </el-form-item>
        <el-form-item label="学院" prop="deptId">
          <el-select v-model="queryParamsData.deptId" clearable placeholder="请选择学院" style="width:160px;">
            <el-option
              v-for="item in optionsListOne"
              :key="item.deptId"
              :label="item.deptName"
              :value="item.deptId">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="设备状态" prop="operate">
          <el-select v-model="queryParamsData.operate" clearable placeholder="请选择状态" style="width:160px;">
            <el-option
              v-for="item in optionsListTwo"
              :key="item.id"
              :label="item.name"
              :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="关联状态" prop="joinCabinetLock">
          <el-select v-model="queryParamsData.joinCabinetLock" clearable placeholder="请选择状态" style="width:160px;">
            <el-option label="已关联" :value="1"></el-option>
            <el-option label="未关联" :value="0"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item>
          <p class="inquire-button-one" @click="handleQuery" style="margin-right:10px;">查询</p>
          <p class="reset-button-one" @click="resetQuery">重置</p>
        </el-form-item>
        <el-form-item style="float: right;">
          <el-col :span="1.5" v-hasPermi="['laboratory:hardware9:add']">
            <p class="add-button-one-90"
               @click="pageToggle(1)"
            ><i class="el-icon-plus"></i>新增</p>
          </el-col>
        </el-form-item>
        <!--<el-form-item style="float: right;">-->
          <!--<el-col :span="1.5" v-hasPermi="['']">-->
            <!--<p class="add-button-one-90"-->
               <!--@click="pageToggle(6)"-->
            <!--&gt;柜锁设置</p>-->
          <!--</el-col>-->
        <!--</el-form-item>-->
        <el-form-item style="float: right;">
          <el-col :span="1.5" v-hasPermi="['laboratory:hardware9:joinCabinet']">
            <p class="add-button-one-90"
               @click="pageToggle(5)"
            >关联机柜</p>
          </el-col>
        </el-form-item>
        <el-form-item style="float: right;">
          <el-dropdown @command="importButton" v-hasPermi="['laboratory:hardware9:import']">
            <div class="form-dropdown-box">
              <img src="@/assets/ZDimages/personnelManagement/icon_jzgxx_dr.png">
              <p>导入</p>
              <img src="@/assets/ZDimages/personnelManagement/icon_jzggl_xljt.png">
            </div>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item style="border-bottom:1px solid #E0E0E0;margin:0 10px;color:#333;" :command="{command:1}">下载模板</el-dropdown-item>
              <el-dropdown-item style="margin:0 10px;color:#666;" :command="{command:2}">导入数据</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </el-form-item>
      </el-form>
      <el-table  border :data="tableList" @selection-change="handleSelectionChange" ref="multipleTable" :row-key="getRowKeys">
        <el-table-column type="selection" width="50" align="center" :reserve-selection="true"/>
        <el-table-column label="智能柜锁编号" align="center" prop="hardwareNum" width="280"/>
        <el-table-column label="柜锁名称" align="center" prop="name" width="180"/>
        <el-table-column label="学院" align="center" prop="deptName" width="160"/>
        <el-table-column label="位置" align="center" prop="posi" width="250" show-overflow-tooltip/>
        <el-table-column label="设备状态" align="center" prop="status" width="100">
          <template slot-scope="scope">{{scope.row.status == 3||scope.row.status == 4?'在线':'离线'}}</template>
        </el-table-column>
        <el-table-column label="关联机柜" align="center" prop="cabinetName" width="160"/>
        <el-table-column label="锁柜ID" align="center" prop="lockId" width="100"/>
        <el-table-column label="摄像头IP" align="center" prop="ipAddress" width="200"/>
        <el-table-column label="采集器编号" align="center" prop="relayCode" width="200"/>
        <!--<el-table-column label="操作最大时长" align="center" prop="operateTime" width="120">-->
          <!--<template slot-scope="scope">{{scope.row.operateTime?scope.row.operateTime+'分钟':''}}</template>-->
        <!--</el-table-column>-->
        <el-table-column label="创建时间" align="center" prop="createTime" width="160"/>
        <el-table-column label="创建人" align="center" prop="createBy" width="120"/>
        <el-table-column label="操作" align="center" width="180" class-name="small-padding fixed-width" v-if="tableButtonType">
          <template slot-scope="scope">
            <div class="button-box">
              <p class="table-min-button" v-hasPermi="['chemical:locklog:list']" @click="pageToggle(4,scope.row)">操作记录</p>
              <el-dropdown @command="moreClick" v-hasPermi="['laboratory:hardware9:edit','laboratory:hardware9:remove']">
                <p class="table-min-button">更多>></p>
                <el-dropdown-menu slot="dropdown">
                  <el-dropdown-item style="border-bottom:1px solid #E0E0E0;margin:0 10px;" :command="{row:scope.row,command:1}" v-hasPermi="['laboratory:hardware9:edit']">编辑</el-dropdown-item>
                  <el-dropdown-item style="margin:0 10px;" :command="{row:scope.row,command:2}" v-hasPermi="['laboratory:hardware9:remove']">删除</el-dropdown-item>
                </el-dropdown-menu>
              </el-dropdown>
            </div>
          </template>
        </el-table-column>
      </el-table>
      <div style="display: flex;height:32px;margin:15px 0;">
        <!--<p style="flex:4;"></p>-->
        <p style="text-align: left;margin:0;line-height:32px;margin-right:20px;font-size:14px;color:#999;">
          <i class="el-icon-warning" style="color:#0183FA;"></i>
          已选择 {{selectedNum}} 项
        </p>
        <div style="flex:5;">
          <pagination
            v-show="total>0"
            :total="total"
            :page.sync="queryParams.pageNum"
            :limit.sync="queryParams.pageSize"
            @pagination="getList"
          />
        </div>
      </div>
    </div>
    <!--导入窗口-->
    <el-dialog title="导入数据" :visible.sync="importOpen" @close="importOpenOff" width="600px" append-to-body class="import-dialog-box">
      <div class="el-upload__text" style="margin:0 0 20px 58px;">提示：导入后的数据将覆盖原有数据</div>
      <el-upload
        class="import-dialog-upLoad-box"
        :drag="true"
        :data="upImportData"
        :action="uploadImgUrl"
        :show-file-list="false"
        :on-success="handleAvatarSuccess"
        :headers="headers"
        :before-upload="beforeAvatarUpload">
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <!--<div class="el-upload__tip" slot="tip">-->
        <!--<el-checkbox v-model="upImportData.upDate">是否更新已经存在的数据</el-checkbox>-->
        <!--</div>-->
        <div class="el-upload__tip" slot="tip">数据导入模板.xlsx<span style="color:#0183FA;cursor: pointer" @click="importTemplate">下载</span></div>
        <div class="el-upload-text-box" slot="tip" v-if="getImportData.downFile">
          <div class="img-text-box">
            <img src="@/assets/ZDimages/personnelManagement/icon_dr_wj.png">
            <p>{{getImportData.textName}}</p>
          </div>
          <p class="text-p">数据导入成功 <span style="color:#0183FA;">{{getImportData.successNum}}</span> 条，失败 <span style="color:#FF6464 ;">{{getImportData.failureNum}}</span> 条</p>
          <div class="img-text-box">
            <img src="@/assets/ZDimages/personnelManagement/icon_dr_sj.png">
            <p style="color:#0183FA;cursor: pointer;" @click="failureExcel">点击下载失败数据报表</p>
          </div>
        </div>
      </el-upload>
      <div slot="footer" class="teacher-import-dialog-button-box">
        <p class="inquire-button-one" @click="importOpenOff">确定</p>
      </div>
      <div class="teacher-import-dialog-position-box" v-if="loading"></div>
    </el-dialog>
    <!--新增/编辑-->
    <el-dialog :title="dialogTitle" :visible.sync="addDialogType" v-if="addDialogType" width="520px" append-to-body class="add-dialog-box">
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="智能柜锁编号：" prop="hardwareNum">
          <el-input v-model="form.hardwareNum" placeholder="最大20个字符，包含大小写字母、数字" onkeyup="value=value.replace(/[^\w\.\/]/ig,'')" maxlength="30" style="width:360px;"/>
        </el-form-item>
        <el-form-item label="智能柜锁名称：" prop="name">
          <el-input v-model="form.name" placeholder="最大10个字符，包含汉字、大小写字母、数字、符号" maxlength="10" style="width:360px;"/>
        </el-form-item>
        <el-form-item label="实验室：" prop="subjectId">
          <el-select
            style="width:360px;"
            v-model="form.subjectId"
            filterable
            remote
            clearable
            @focus="selectFocus"
            reserve-keyword
            @clear="clearClick"
            placeholder="搜索选择实验室"
            :remote-method="getSelectList"
            :loading="loading">
            <el-option
              v-for="item in selectList"
              :key="item.id"
              :label="item.name"
              :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="锁柜ID：" prop="lockId">
          <el-input v-model="form.lockId" placeholder="0-253" maxlength="3" style="width:360px;" onkeyup="value=value.replace(/[^\d]/g,'')"/>
        </el-form-item>
        <el-form-item label="摄像头IP：" prop="ipAddress">
          <el-input v-model="form.ipAddress" placeholder="请输入摄像头IP" maxlength="20" style="width:360px;"/>
        </el-form-item>
        <el-form-item label="采集器编号：" prop="relayCode">
          <el-input v-model="form.relayCode" placeholder="请输入采集器编号" maxlength="20" onkeyup="value=value.replace(/[^\w\.\/]/ig,'')" style="width:360px;"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--柜锁设置-->
    <el-dialog title="柜锁设置" :visible.sync="setUpType" v-if="setUpType" width="520px" append-to-body class="add-dialog-box">
      <el-form ref="setUpForm" :model="setUpForm" :rules="rules" label-width="100px">
        <el-form-item label="操作时长：" prop="operateTime">
          <el-input v-model="setUpForm.operateTime" placeholder="请输入操作时长" min="1" max="999" maxlength="3" style="width:360px;"
                    onkeyup="this.value=this.value.replace(/\D/g,'')" onafterpaste="this.value=this.value.replace(/\D/g,'')">
            <template slot="append">分钟</template>
          </el-input>
        </el-form-item>
        <p style="font-size:14px;line-height:20px;color:#999;">
          <i class="el-icon-warning" style="color:#FFA312;font-size:16px;margin-left:100px;"></i>
          设置开锁后操作的最大有效时长
        </p>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="setUpFormSubmitForm">确 定</el-button>
        <el-button @click="setUpFormCancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--操作记录-->
    <operation-record v-if="pageType == 4" :operationRecordPropsData="operationRecordPropsData"></operation-record>
    <!--关联机柜-->
    <associated-cabinet-lock v-if="pageType == 5" :associatedCabinetLockPropsData="associatedCabinetLockPropsData"></associated-cabinet-lock>
  </div>
</template>

<script>
  import mqtt from 'mqtt'
  import { hxpSmartTerminal,filterDept,getSubList,addHxpSmartTerminal,putHxpSmartTerminal,getHxpSmartTerminal,delHxpSmartTerminal } from "@/api/medicUniversity-3_1/index";
  import { listHardware, delHardware, addHardware, updateHardware,setLock,getCabinetLockList } from "@/api/medicUniversity-3_1/index";
  import { listDepartments } from "@/api/system/dept";
  import { getToken } from "@/utils/auth";
  import associatedCabinetLock from "./associatedCabinetLock.vue"
  import operationRecord from "./operationRecord.vue"
  export default {
    name: "smartAlarm",
    components: {
      associatedCabinetLock,
      operationRecord
    },
    data() {
      let digitalJudgment = (rule, value, callback) => {
        if(value>253||value<0){
          return callback(new Error(''));
        }else{
          callback()
        }
      }
      return {
        //MQTT请求参数-设备
        mtopic:"lab/hardware/data",
        client:{},
        // table操作按钮校验
        tableButtonType:this.hasPermiDom(['chemical:locklog:list','laboratory:hardware5:edit','laboratory:hardware5:remove']),
        //上传相关配置
        uploadImgUrl: window.location.href.split('://')[0]+'://' + process.env.VUE_APP_BASE_API + "/laboratory/hardware/importData", // 上传地址
        headers: {
          Authorization: "Bearer " + getToken(),
        },
        // 遮罩层
        loading:false,
        //页面状态
        pageType:1,
        // 搜索数据
        queryParamsData:{
          pageNum:1,
          pageSize:10,
        },
        // 搜索实际发送数据
        queryParams:{
          pageNum:1,
          pageSize:10,
        },
        //数据数量
        total:0,
        //数据数组
        tableList:[],
        //表格扩展选择器---需要在@selection-change绑定的方法内监控selection数组长度
        selectedNum:0,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        //学院列表
        optionsListOne:[],
        //状态列表
        optionsListTwo:[{id:"ONLINE",name:"在线"},{id:"OFFLINE",name:"离线"}],
        //导入弹层开关
        importOpen:false,
        //导入数据
        upImportData:{
          sysUserEnable:true,
          upDate:false,
          terminalType:"AI_CABINETLOCK",
        },
        getImportData:{
          downFile:false,
          successNum:0,
          failureNum:0,
          textName:"",
        },
        //编辑新增相关
        dialogTitle:"",
        addDialogType:false,
        form:{},
        selectList:[],
        selectListData:[],
        rules:{
          hardwareNum: [
            { required: true, trigger: "blur", message: "最大20个字符，包含大小写字母、数字" },
            { required: true, message: "最大20个字符，包含大小写字母、数字", validator: this.spaceJudgment, trigger: "blur" }
          ],
          name: [
            { required: true, trigger: "blur", message: "最大10个字符，包含汉字、大小写字母、数字、符号" },
            { required: true, message: "最大10个字符，包含汉字、大小写字母、数字、符号", validator: this.spaceJudgment, trigger: "blur" }
          ],
          subjectId: [
            { required: true, trigger: "blur", message: "搜索选择实验室" },
          ],
          operateTime: [
            { required: true, trigger: "blur", message: "请输入操作时长" },
            { required: true, message: "请输入操作时长", validator: this.spaceJudgment, trigger: "blur" }
          ],
          lockId: [
            { required: true, trigger: "blur", message: "请输入0-253之间的数字" },
            { required: true, message: "请输入0-253之间的数字", validator: this.spaceJudgment, trigger: "blur" },
            { required: true, message: "请输入0-253之间的数字", validator: digitalJudgment, trigger: "blur" }
          ],
          ipAddress: [
            { required: true, trigger: "blur", message: "请输入摄像头ip" },
            { required: true, message: "请输入摄像头ip", validator: this.spaceJudgment, trigger: "blur" }
          ],
          relayCode: [
            { required: true, trigger: "blur", message: "请输入采集器编号" },
            { required: true, message: "请输入采集器编号", validator: this.spaceJudgment, trigger: "blur" }
          ],
        },
        //锁柜设置
        setUpType:false,
        setUpForm:{},
        //操作记录传参数据
        operationRecordPropsData:{},
        //关联记录传参数据
        associatedCabinetLockPropsData:{},
      };
    },
    created() {

    },
    mounted(){
      this.subscriptionMQTT();
      this.filterDept();
      this.listDepartments();
      this.getList();
    },
    methods: {
      selectFocus(){
        if(!this.selectList[0]){
          this.filterDept();
        }
      },
      //更多按钮
      moreClick(data){
        let self = this;
        if(data.command == 1){
          this.pageToggle(2,data.row);
        }else if(data.command == 2){
          this.pageToggle(3,data.row);
        }
      },
      //获取学院列表
      listDepartments(){
        listDepartments().then(response => {
          this.optionsListOne = response.data;
        });
      },
      pageToggle(type,item){
        let self = this;
        if(type == 0){
          this.pageType = 1;
          this.getList();
        }else if(type == 1){
          //新增
          this.dialogTitle = '新增';
          this.$set(this,'form',{
            hardwareNum:"",
            subjectId:""
          });
          this.clearClick();
          this.addDialogType = true;
        }else if(type == 2){
          // 编辑
          this.dialogTitle = '编辑';
          let obj = {
            id:item.id,
            subjectId:item.subjectId,
            name:item.name,
            hardwareNum:item.hardwareNum,
            lockId:item.lockId,
            ipAddress:item.ipAddress,
            relayCode:item.relayCode,
          };
          this.$set(this,'form',obj);
          this.clearClick();
          this.addDialogType = true;
        }else if(type == 3){
          // 删除
          if(item.joinCabinetId){
            this.msgError('已关联机柜,无法删除')
            return
          }
          this.$confirm('确认要删除吗?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
            delHardware(item.id).then(response => {
              if (response.code == 200){
                self.msgSuccess(response.msg);
                self.getList();
              }
            });
          }).then(() => {
          }).catch(() => {});
        }else if (type == 4){
          //操作记录
          this.operationRecordPropsData = item;
          this.pageType = 4;
        }else if (type == 5){
          //关联机柜
          if(self.ids.length>0) {
            let obj = {
              ids:this.ids+'',
            }
            getCabinetLockList(obj).then(response => {
              this.associatedCabinetLockPropsData = response.rows;
              this.pageType = 5;
            });
          }else{
            this.msgError('请选择要关联的锁柜')
          }
        }else if (type == 6){
          //锁柜设置
          if(self.ids.length>0) {
            this.setUpForm = {
              operateTime:"",
            }
            this.setUpType = true;
          }else{
            this.msgError('请选择要设置的锁柜')
          }
        }
      },
      //查询当前院系
      filterDept(){
        filterDept().then(response => {
          let idText = "";
          for(let i=0;i<response.data.length;i++){
            if(i==0){
              idText = idText + response.data[i].deptId;
            }else{
              idText = idText +','+ response.data[i].deptId;
            }
          }
          //查询院系下实验室
          getSubList(idText).then(response => {
            //当前列表
            this.selectList = JSON.parse(JSON.stringify(response.data));
            //原始列表数据
            this.selectListData = JSON.parse(JSON.stringify(response.data));
          });
        });
      },
      /** 实验室-本地懒加载 */
      getSelectList(val) {
        let self = this;
        let list = [];
        for(let i=0;i<self.selectListData.length;i++){
          if(self.selectListData[i].name.indexOf(val) != -1){
            list.push(self.selectListData[i]);
          }
        }
        this.selectList = JSON.parse(JSON.stringify(list))
      },
      //实验室选中清除
      clearClick(){
        this.selectList = JSON.parse(JSON.stringify(this.selectListData))
      },
      submitForm(){
        this.$refs["form"].validate((valid) => {
          if (valid) {
            if(this.form.id){
              //编辑
              this.form.type = "AI_CABINETLOCK";
              updateHardware(this.form).then(response => {
                if (response.code == 200){
                  this.addDialogType = false;
                  this.msgSuccess(response.msg);
                  this.getList();
                }
              });
            }else{
              //新增
              this.form.type = "AI_CABINETLOCK";
              addHardware(this.form).then(response => {
                if (response.code == 200){
                  this.addDialogType = false;
                  this.msgSuccess(response.msg);
                  this.resetQuery();
                }
              });
            }
          }
        })
      },
      cancel(){
        this.addDialogType = false;
      },
      //柜锁设置
      setUpFormSubmitForm(){
        this.$refs["setUpForm"].validate((valid) => {
          if (valid) {
            let obj = {
              ids:this.ids,
              operateTime:parseInt(this.setUpForm.operateTime),
            }
            setLock(obj).then(response => {
              if(response.code == 200){
                this.setUpType = false;
                this.msgSuccess(response.msg);
                this.getList();
              }
            });
          }
        })
      },
      setUpFormCancel(){
        this.setUpType = false;
      },
      //获取数据列表
      getList(){
        this.queryParamsData = JSON.parse(JSON.stringify(this.queryParams));
        this.queryParamsData.type = 'AI_CABINETLOCK';
        listHardware(this.queryParamsData).then(response => {
          this.selectedNum = 0;
          this.ids = [];
          this.total = response.total;
          this.tableList = response.rows;
        });
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParamsData.pageNum = 1;
        this.queryParamsData.pageSize = 10;
        this.queryParams = JSON.parse(JSON.stringify(this.queryParamsData));
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.$set(this,'queryParamsData',{});
        this.$set(this,'queryParams',{});
        this.handleQuery();
      },
      //导入页面关闭
      importOpenOff(){
        this.importOpen = false;
        this.getImportData.downFile = false;
        this.getImportData.successNum = 0;
        this.getImportData.failureNum = 0;
        this.getImportData.textName = "";
      },
      /** 导入按钮操作 */
      importButton(item){
        if(item.command == 1){
          //  下载模板
          this.download('/laboratory/hardware/importTemplate', {}, `导入模板.xlsx`)
        }else if(item.command == 2){
          //  导入数据
          console.log('导入数据');
          this.importOpen = true;
        }
      },
      /** 下载模板操作 */
      importTemplate() {
        this.download('/laboratory/hardware/importTemplate', {}, `导入模板.xlsx`)
      },
      /*下载失败列表*/
      failureExcel(){
        this.download('/laboratory/hardware/importErrorData', {}, `失败报表.xlsx`)
      },
      //****************************************导入功能**************************************
      handleAvatarSuccess(res, file) {
        if(res.code == 200){
          if(res.data.downFile){
            this.getImportData.downFile = res.data.downFile
            this.getImportData.successNum = res.data.successNum
            this.getImportData.failureNum = res.data.failureNum
          }else{
            this.msgSuccess(res.msg);
            this.importOpen = false;
            this.resetQuery();
          }
          // this.getImportData.downFile = res.data.downFile
          // this.getImportData.successNum = res.data.successNum
          // this.getImportData.failureNum = res.data.failureNum
          // this.importOpen = false;
          // this.getList();
        }else{
          this.msgError(res.msg);
        }
        this.loading = false;
      },
      beforeAvatarUpload(file) {
        let type = false;
        console.log('file',file);
        if (file.type == 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' || file.type == 'application/vnd.ms-excel') {
          this.getImportData.textName = file.name;
          type = true;
          this.loading = true;
        }else{
          this.msgError('只能上传xls/xlsx格式文件')
          type = false;
        }
        return type;
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.selectedNum = selection.length;
        this.ids = selection.map(item => item.id);
        this.single = selection.length != 1;
        this.multiple = !selection.length;
      },
      /*===记录勾选数据===
        需要再el-table 添加  :row-key="getRowKeys"
        需要在selection 添加 :reserve-selection="true"
      */
      getRowKeys(row) {
        return row.id
      },
      //MQTT订阅
      subscriptionMQTT(){
        let self = this;
        this.client = mqtt.connect(process.env.VUE_APP_BASE_MQTT_API, {
          username: process.env.VUE_APP_BASE_MQTT_USERNAME,
          password: process.env.VUE_APP_BASE_MQTT_PASSWORD
        });
        this.client.on("connect", e =>{
          console.log("连接成功");
          this.client.subscribe(this.mtopic, (err) => {
            if (!err) {
              console.log("订阅成功:" + this.mtopic);
            }
          });
        });
        this.client.on("message", (topic, message) => {
          if (message){
            let data = JSON.parse(message)
            if(topic == this.mtopic){
              for(let i=0;i<data.data.length;i++){
                for(let o=0;o<self.tableList.length;o++){
                  if(data.data[i].num == self.tableList[o].id){
                    if(data.data[i].hardwareOperate == 'CLOSE'){
                      //停用并上线
                      self.$set(self.tableList[o],'status',4);
                    }else if(data.data[i].hardwareOperate == 'OPEN'){
                      //启用并上线
                      self.$set(self.tableList[o],'status',3);
                    }else if(data.data[i].hardwareOperate == 'OFFLINE'){
                      //离线
                      self.$set(self.tableList[o],'status',0);
                    }
                  }
                }
              }
            }
          }
        });
      },
      //取消订阅关闭MQTT连接
      offMQTT(){
        this.client.unsubscribe(this.mtopic, error => {
          if (error) {
            console.log('Unsubscribe error', error)
          }
        })
        this.client.end();
        this.client = {};
      },
    },
    beforeDestroy() {
      //清除定时器
      let self = this;
      self.offMQTT();
      console.log("beforeDestroy");
    },
  }
</script>

<style scoped lang="scss">
  .smartAlarm{
    flex:1;
    display: flex;
    flex-direction: column;
    overflow: hidden!important;
    .smartAlarm-min-page{
      flex: 1;
      display: flex;
      flex-direction: column;
      overflow: hidden;
      padding:20px !important;
    }
    p{
      margin:0;
      padding:0;
    }
    .form-box{
      .form-dropdown-box{
        display: flex;
        margin:0;
        padding:0 10px;
        cursor: pointer;
        height:40px;
        img:nth-child(1){
          width:16px;
          height:16px;
          margin-top:12px;
        }
        p{
          width:47px;
          text-align: center;
          font-size:14px;
          margin:0;
          line-height:40px;
        }
        img:nth-child(3){
          width:10px;
          height:6px;
          margin-top:17px;
        }
      }
    }
    .button-box{
      display: flex;
    }
  }
</style>
<style lang="scss">
  .import-dialog-box{
    .import-dialog-upLoad-box{
      .el-upload{
        width:450px;
        margin:0 55px;
        .el-upload-dragger{
          width:450px;
          .el-icon-upload{
            font-size:100px;
            color:#CBE6FE;
          }
          .el-upload__text{
            margin-top:20px;
          }
        }
      }
      .el-upload__tip{
        margin-left:60px;
        font-size:14px;
        margin-top:10px;
      }
      .el-upload-text-box{
        background: #F5F5F5;
        border-radius: 10px;
        margin:15px 30px 0;
        padding:0 20px 15px;
        overflow: hidden;
        *{
          margin:0;
        }
        .img-text-box{
          display: flex;
          margin-top:15px;
          img{
            width:16px;
            height:16px;
            margin-right:13px;
          }
          p{
            height:16px;
            line-height:16px;
            font-size:12px;
          }
        }
        .text-p{
          margin-top:15px;
          margin-left:29px;
          height:16px;
          line-height:16px;
          font-size:12px;
        }
      }
    }
    .teacher-import-dialog-button-box{
      display: flex;
      width:190px;
      margin:0 auto;
      p{
        width:70px;
        height:30px;
        line-height:30px;
        font-size:14px;
        margin:0 auto;
      }
    }
    .teacher-import-dialog-position-box{
      width:100%;
      height:100%;
      position: absolute;
      top:0;
      left:0;
      z-index: 999;
      background: rgba(255,255,255,0.4);
      border-radius:20px;
    }
  }
</style>
